package source
{
	import net.flashpunk.World;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import flash.geom.Point;
	import net.flashpunk.utils.Draw;
	/**
	 * ...
	 * @author Time
	 */
	public class Game extends World
	{
		private var particles:Point = new Point(20, 20);
		private var particleSize:int = 20;
		private var particleMargin:int = 1;
		
		private var normal:Boolean = false;
		
		public function Game(rocky:Boolean=true) 
		{
			//FP.console.enable();
			normal = rocky;
			super();
		}
		override public function begin():void
		{
			var w:int = (FP.width - (particleSize + particleMargin) * particles.x) / 2;
			var h:int = (FP.height - (particleSize + particleMargin) * particles.y)/2;
			for (var i:int = 0; i < particles.x; i++)
			{
				for (var j:int = 0; j < particles.y; j++)
				{
					var t:Point = new Point(w + (particleSize + particleMargin) * i, h + (particleSize + particleMargin) * j);
					var size:int = particleSize / 2 + particleSize * Math.random() / 2;
					if (normal)
					{
						size = particleSize;
					}
					FP.world.add(new Particle(t.x, t.y, new Point(0, 0), size));
				}
			}
		}
		override public function update():void
		{
			if (Input.released(Key.SPACE))
			{
				FP.world = new Game(true);
			}
			if (Input.released(Key.C))
			{
				FP.world = new Game(false);
			}
			super.update();
		}
		override public function render():void
		{
			super.render();
		}
		
	}

}